Program My3D;

{ WolfEnstein clone - with 3D Texture mapping

Copyright (C) 1997-98 TothPaul@mygale.org
 http://www.mygale.org/~tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

{$I MYOPT.PAS}

Uses
 Real3D,MyDef,Controls,Font7x5;

Const
 WORLD='WORLD4.DAT'; {'WOLF3D0.DAT';}
 WALLS='WALLS.DAT';
 GAMEPAL='GAMEPAL.DAT';

Function CheckParm(Value:string):boolean;
 var
  s:string;
  i,j:byte;
 begin
  for i:=1 to ParamCount do begin
   s:=ParamStr(i);
   for j:=1 to length(s) do s[j]:=upcase(s[j]);
   if s=Value then begin
    CheckParm:=True;
    exit;
   end;
  end;
  CheckParm:=false;
 end;

Var
 RoomSize   :^TRoomSize;
 Room       :word;
 Picture    :word;
 Wall       :byte;

 Frames     :longint;
 Time       :longint;
 Timer      :longint absolute $40:$6C;
 Ticks      :longint;

Var
 HWorld  :file;
 HPicture:file;
 HPalette:file;

 StartMem:LongInt;
 GameMem:LongInt;


 WallX,WallY:longint;
 NextX,NextY:longint;
 MoveX,MoveY:longint;
 dist :longint;
 dist2:longint;


Const
 Flags:array[0..3] of char=('','/','','\');

var
 f:byte;

Function IntToStr(I:Integer):string;
 var
  s:string;
 begin
  Str(I,S);
  IntToStr:=S;
 end;

Function InsideRoom(Room:word):boolean;
 begin
  InsideRoom:=false;

  { crossing walls }
  With Rooms^[Room]^ do begin

   NextX:=Left;
   NextY:=Top;

   For Wall:=1 to WallCount do begin (* follow walls *)

    With Walls[Wall] do begin (* for this wall, where is his other side *)

     WallX:=NextX;
     WallY:=NextY;

     Case Axis of
      East : begin NextX:=WallX+Width; end;
      South: begin NextY:=WallY+Width; end;
      West : begin NextX:=WallX-Width; end;
      North: begin NextY:=WallY-Width; end;
     end;

     { okay, now where's the wall }

     if ((wallx<movex)and(movex<nextx))
      or((wallx>movex)and(movex>nextx))
      or((wally<movey)and(movey<nexty))
      or((wally>movey)and(movey>nexty)) then begin

     dist:=(
            (MoveX-WallX) * (NextY-WallY) div width
           +(MoveY-WallY) * (NextX-WallX) div width
           ) {div (Width)};
  il faut que hje dtermine le signe de DIST !!!!!!!!!!!!!!!!!!!
(*     dist2:=(
            (PlayerX-WallX) * (NextY-WallY) div width
           +(PlayerY-WallY) * (NextX-WallX) div width
            ) {div (Width)};

     if (dist2<0) then dist:=-dist; *)

     if dist<16 then begin
      if door=0 then exit; { can't cross wall }
      if dist<0 then begin { throug a door }
       PlayerR:=door;       { setup it now... }
       if InsideRoom(Door) then { recursive check }
        InsideRoom:=true { okay, for now of recursive room }
       else
        PlayerR:=Room; { restore Player Room }
      end else
       InsideRoom:=true;
      exit; { exit anyway }
     end;

     end;

    end;
   end;
  end;

  InsideRoom:=true; { sucessfully move inside this room }
 end;

begin
 StartMem:=MemAvail;

 WriteLn('My-3D CopyRight (C) 1997-98, Paul Toth');
 Writeln(' Memory : ',MemAvail);

{ no more VESA mode - look at Version 3 for VESA support
 if CheckParm('/?') then begin
  VesaInfo;
  WriteLn(' use VESA mode $101 or VGA Mode $13');
  WriteLn(' /V = Force VGA Mode 13h (320x200)');
  exit;
 end;
}

{ Get World DATA }
 Write(' Reading WORLD ');
 Assign(HWorld,WORLD); Reset(HWorld,1);

 BlockRead(HWorld,PlayerX,SizeOf(PlayerX));
 BlockRead(HWorld,PlayerY,SizeOf(PlayerY));
 BlockRead(HWorld,PlayerR,SizeOf(PlayerR));
 PlayerA:=PlayerR*128 div 180;
 BlockRead(HWorld,PlayerR,SizeOf(PlayerR));

 BlockRead(HWorld,RoomCount,2);
 BlockRead(HWorld,FirstDoor,SizeOf(FirstDoor));

 GetMem(RoomSize,2*RoomCount);
 BlockRead(HWorld,RoomSize^,2*RoomCount);

{ Reading Rooms DATA }
 GetMem(Rooms,4*RoomCount);
 For Room:=1 to RoomCount do begin
  Write('.');
  GetMem(Rooms^[Room],RoomSize^[Room]);
  BlockRead(HWorld,Rooms^[Room]^,RoomSize^[Room]);
 end;
 WriteLn;
 Close(HWorld);

{ Get Wall DATA }
 Write(' Reading WALLS ');
 Assign(HPicture,WALLS); Reset(HPicture,1);
 PictureCount:=FileSize(HPicture) div PictureSize;
 GetMem(Pictures,4*PictureCount);
 For Picture:=1 to PictureCount do begin
  Write('.');
  GetMem(Pictures^[Picture],PictureSize);
  BlockRead(HPicture,Pictures^[Picture]^,PictureSize);
 end;
 WriteLn;
 Close(HPicture);

{ Get Palette }
 WriteLn(' Reading Palette');
 Assign(HPalette,GAMEPAL); Reset(HPalette,1);
 GetMem(Palette,PaletteSize);
 BlockRead(HPalette,Palette^,PaletteSize);
 Close(HPalette);

{ Now Start the game }

 InitControls;

 StartGame;

 OutText(1, 2,'BP7 3D-Engine by TothPaul@mygale.org');
 OutText(1,12,'http://www.mygale.org/~tothpaul');

 if GetMaxX=640 then
  OutText(490,GetMaxY-StatusBar+1,'(use /V for 320x200 mode)');

 f:=0;

 GameMem:=MemAvail;

(* test *)
 PlayerX:=32;
 PlayerY:=16;
 PlayerA:=Round(00*256/180);
(* test *)

 Psin:=s64[playerA];
 Pcos:=c64[playerA];
(*
 wsin:=64*psin;
 wcos:=64*pcos;
*)
 Time:=Timer;
 Frames:=0;
 Ticks:=Timer;

 Repeat

  ShowView;
  Inc(Frames);

  { Status Bar }

  OutText(1,22,
   'Room:'+IntToStr(PlayerR)+
     ' C:'+IntToStr(Columns)+
     ' P:'+IntToStr(Portals)+
   ' - X:'+IntToStr(PlayerX)+
     ' Y:'+IntToStr(PlayerY)+
     ' H:'+IntToStr(PlayerH)+
     ' G:'+IntToStr(Gravity)+
     ' A:'+IntToStr(Round(PlayerA*180/256))+
     ' T:'+IntToStr(Round(100*(Timer-Ticks)/18.2))+
     ' '+Flags[f]+'  ');
  Ticks:=Timer;

  inc(f); if f=4 then f:=0;

  Gravity:=0;
{  Repeat }
   CheckControls;
{  Until Done or (Turn<>0)or(Speed<>0); }

  dec(Rooms^[PlayerR]^.Height,Gravity);

  if Turn<>0 then begin
   PlayerA:=PlayerA+(Turn);
   psin:=s64[playera];
   pcos:=c64[playera];
(*
   wsin:=64*psin;
   wcos:=64*pcos;
*)
  end;

(*  speed:=10; *)

  { new ! }
  if Speed<>0 then begin { the player is moving }

   MoveX:=PlayerX-Speed*pSin div Trigo;
   MoveY:=PlayerY-Speed*pCos div Trigo;

   if InsideRoom(PlayerR) then begin
    PlayerX:=MoveX;
    PlayerY:=MoveY;
   end;

  end;
(*
  if Speed<>0 then begin

   PlayerX:=PlayerX-Speed*pSin div Trigo;
   PlayerY:=PlayerY-Speed*pCos div Trigo;

  { Range Checking }

   With (Rooms^[PlayerR]^) do begin

    Wall:=1;
   { Check North Walls }

    if PlayerY<Top then begin

     while (Walls[Wall].Axis=East) do begin
      Room:=Walls[Wall].Door;
      if (Room>0)and((Room<FirstDoor)or(Rooms^[Room]^.Door.Open>60)) then
       With (Rooms^[Room]^) do
        if (PlayerX>Left)and(PlayerX<Right) then begin
         PlayerR:=Room;
         break;
        end;
      inc(wall);

     end;

    end;

   { Check East Walls }

    if PlayerX>Right then begin

     While Walls[Wall].Axis<>South do Inc(Wall);

     while (Walls[Wall].Axis=South) do begin
      Room:=Walls[Wall].Door;
      if (Room>0)and((Room<FirstDoor)or(Rooms^[Room]^.Door.Open>60)) then
       With (Rooms^[Room]^) do
        if (PlayerY>Top)and(PlayerY<Bottom) then begin
         PlayerR:=Room; break;
        end;
      inc(wall)
     end;

    end;

   { Check South Walls }

    if PlayerY>Bottom then begin

     While Walls[Wall].Axis<>West do Inc(Wall);

     while (Walls[Wall].Axis=West) do begin
      Room:=Walls[Wall].Door;
      if (Room>0)and((Room<FirstDoor)or(Rooms^[Room]^.Door.Open>60)) then
       With (Rooms^[Room]^) do
        if (PlayerX>Left)and(PlayerX<Right) then begin
         PlayerR:=Room; break;
        end;
      inc(wall)
     end;

    end;

   { Check West Walls }

    if PlayerX<Left then begin

     While Walls[Wall].Axis<>North do Inc(Wall);

     while (Wall<=WallCount) do begin
      Room:=Walls[Wall].Door;
      if (Room>0)and((Room<FirstDoor)or(Rooms^[Room]^.Door.Open>60)) then
       With (Rooms^[Room]^) do
        if (PlayerY>Top)and(PlayerY<Bottom) then begin
         PlayerR:=Room; break;
        end;
      inc(wall)
     end;

    end;

   end;

   { Now limite Player Pos }
   With (Rooms^[PlayerR]^) do begin
    if PlayerX<=Left   then PlayerX:=Left+1;
    if PlayerX>=Right  then PlayerX:=Right-1;
    if PlayerY<=Top    then PlayerY:=Top+1;
    if PlayerY>=Bottom then PlayerY:=Bottom-1;
   end;

  end;
*)
 Until Done;

 StopGame;

{ Free memory }
 FreeMem(Palette,PaletteSize);

 For Picture:=1 to PictureCount do begin
  FreeMem(Pictures^[Picture],PictureSize);
 end;
 FreeMem(Pictures,4*PictureCount);

 For Room:=1 to RoomCount do begin
  FreeMem(Rooms^[Room],RoomSize^[Room]);
 end;
 FreeMem(Rooms,4*RoomCount);
 FreeMem(RoomSize,2*RoomCount);

{ Back to DOS }
 WriteLn('Back to DOS');
 WriteLn(' StartMem = ',StartMem);
 WriteLn(' GameMem  = ',GameMem,' used ',StartMem-GameMem);
 WriteLn(' MemAvail = ',MemAvail,' lost ',StartMem-MemAvail);
 WriteLn('Frames drawn = ',Frames);
 WriteLn('Frame Rate   = ',Frames*18.2/(Timer-Time):0:2,' /s');
 WriteLn('Regards');
 WriteLn('Paul.');

end.