unit mywin;

interface

uses windows,MyDef2;

Type
 TDIB=array[0..1024*768] of byte; // maximum resolution !

Var
 DIB:^TDIB;
 wPalette:THandle;
Const
 GetMaxX:integer=320;
 GetMaxY:integer=200;
 LineSize:integer=320;

Procedure InitGraph;
Procedure TextMode;
Procedure SetPalette;
Procedure FillWord(Var Data; Count,Value:dword); assembler;

implementation

Procedure InitGraph;
 begin
 { Create DIB }
  zoom:=GetMaxX;
  LineSize:=(GetMaxX+3) and $FFFC;
  GetMem(DIB,Linesize*GetMaxY);
 { clear screen }
  FillChar(DIB^,LineSize*GetMaxY,1);
 end;

Procedure TextMode;
 begin
  DeleteObject(wPalette);
  FreeMem(DIB);
 end;

Procedure SetPalette;
 Var
  Pal256:pLogPalette;
  i:integer;
 begin
{ Set Palette }
 GetMem(Pal256,4+4*256);
 with Pal256^ do begin
  palVersion:=$300;
  palNumEntries:=256;
 { convert DOS RGB64 palette to Windows RGB256 palette }
  for i:=0 to 255 do
   with palPalEntry[i] do begin
    peRed  :=Palette^[i,0] shl 2;
    peGreen:=Palette^[i,1] shl 2;
    peBlue :=Palette^[i,2] shl 2;
    peFlags:=PC_NOCOLLAPSE;
   end;
 end;
 WPalette:=CreatePalette(Pal256^);
 FreeMem(Pal256,4+4*256);
end;

Procedure FillWord(Var Data; Count,Value:dword); assembler;
{ eax = @Data
  edx = Count
  ecx = Value }
 asm
  push edi       // save edi (needed with Delphi)
   mov edi,eax   // get @data
   mov eax,ecx   // get value
   mov ecx,edx   // get count
   rep stosw
  pop edi
 end;

end.
