program mywin3d;

{ WolfEnstein clone - with 3D Texture mapping - Delphi 2 version

Copyright (C) 1997-98 TothPaul@mygale.org
 http://www.mygale.org/~tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

{$i myopt.pas}

{$r resource}

{$define keystate}

uses
  windows, messages, mmsystem,
  sysutils,
  MyDef, Real3d, sound;

Const
 WORLD='WORLD.DAT';     { look at WORLD.DPR to build a world }
 WALLS='WALLS.DAT';     { Walls pictures from WolfEnstein }
 GAMEPAL='GAMEPAL.DAT'; { Game palette (RGB/64) from WolfEnstein }

Var
 RoomSize   :^TRoomSize;
 Room       :word;
 Picture    :word;
 Wall       :byte;

Var
 HWorld  :file;
 HPicture:file;
 HPalette:file;

 WallX,WallY:real;
 NextX,NextY:real;
 rx1,ry1:real;
 rx2,ry2:real;
 MoveX,MoveY:integer;
// Vars for Windows
Type
 { Replace the TBitmapInfo for dib_pal_colors on StretchDiBits API }
 TPalBitmapInfo=record
  bmiHeader:TBitmapInfoHeader;
  bmiColors:Array[0..255] of Word;
 end;

var
 hWnd:THandle;
 Msg :TMsg;
 Width,Height:integer;
 BitsInfo:TPalBitmapInfo;
 i:integer;
 refresh:boolean;
 speed:integer;
 speedup,speeddown:integer;
 turnright,turnleft:integer;

Function InsideRoom(Room:word):boolean;
 var
  wall:word;
  walla:real;
 begin
  // the purpose of this function is to determine whenever the player
  // is still inside his room, cross a wall or a door ...
  with Rooms^[room]^ do begin
   NextX:=Left-MoveX;
   NextY:=Top -MoveY;
   for wall:=1 to wallcount do begin
    with walls[wall] do begin
     WallX:=NextX;
     WallY:=NextY;

     wCos:=cos(Axis*PI/128);
     wSin:=sin(Axis*PI/128);
     NextX:=WallX-width*wSin;
     NextY:=WallY-width*wCos;

     // okay, we know wall pos, we need to make a rotation
     // to place the wall horizontaly (WallY=NextY), then check X & Y
     rx1:=(WallY*wCos)+(WallX*wSin);
     ry1:=(WallX*wCos)-(WallY*wSin);
     rx2:=(NextY*wCos)+(NextX*wSin);
    (*
     ry2:=(NextX*wCos)-(NextY*wSin);
     if (ry1<>ry2) then begin
      MessageBox(0,'ry1<>ry2','error !',mb_ok);
      halt;
     end;
    *)
     if (((rx1<=0)and(rx2>0))or((rx1>=0)and(rx2<0))) // the wall cross, player way
     and(ry1>-16) then // and we are to close !
      if door>0 then begin // or it's a door
       if ry1>0 then begin // and we've cross it !
        PlayerR:=door;
        Result:=InsideRoom(Door);
        if not result then PlayerR:=Room else SetWindowText(hWnd,pchar('room #'+inttostr(door)));
        exit;
       end;
      end else begin
       result:=false; // can't be so close from a wall !
       exit;
      end;
    end; // walls[wall]
   end; // for walls
  end;
  result:=true;
 end;

Procedure DrawDib;
 var
  DC:hDC;
  s:integer;
  c:integer;
 begin
  DC:=GetDC(HWnd);
//  SetStretchBltMode(DC, STRETCH_DELETESCANS);
  SelectPalette(DC,WPalette,False);
  RealizePalette(DC);
  SetDIBitsToDevice(
   DC,	// handle of device context
   0,	// x-coordinate of upper-left corner of dest. rect.
   0,	// y-coordinate of upper-left corner of dest. rect.
   GetMaxX, // source rectangle width
   GetMaxY, // source rectangle height
   0,	// x-coordinate of lower-left corner of source rect.
   0,	// y-coordinate of lower-left corner of source rect.
   0,	// first scan line in array
   GetMaxY, // number of scan lines
   dib,// address of array with DIB bits
   pBitmapInfo(@BitsInfo)^, //  address of structure with bitmap info.
   dib_pal_colors  // RGB or palette indices
   );
  ReleaseDC(HWnd,DC);
 end;

Function WinProc(hWnd: THandle; Msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
begin
 Result:=0; // default reply
 case msg of

  WM_PAINT  : begin
               DrawDib;
              // if you don't call DefWindowProc, "About Box" bugs ???
               Result:=(DefWindowProc(hWnd, msg, wParam, lParam));
              end;
  WM_SIZE   : begin
               Width :=(lParam and $ffff);
               Height:=(lParam shr 16);
               zoom:=width;
               with bitsinfo.bmiHeader do begin
                biwidth:=width;
                biheight:=height;
               end;
               ResetSize(width,Height);
               //Refresh:=true;
              end;
 {$ifndef keystate}
  WM_KEYDOWN : begin
                case wParam of
                 vk_left : inc(TurnLeft);
                 vk_right: inc(TurnRight);
                 vk_up   : Inc(SpeedUp);
                 vk_down : Inc(SpeedDown);
//                 else Result:=(DefWindowProc(hWnd, msg, wParam, lParam));
                end;
                //Refresh:=true;
               end;
  WM_KEYUP : begin
              case wParam of
               vk_left : TurnLeft:=0;
               vk_right: TurnRight:=0;
               vk_up   : SpeedUp:=0;
               vk_down : SpeedDown:=0;
//               else Result:=(DefWindowProc(hWnd, msg, wParam, lParam));
              end;
              //Refresh:=true;
             end;
  {$endif}
  WM_ACTIVATE: if wParam=WA_INACTIVE then begin
                TurnLeft:=0;
                TurnRight:=0;
                SpeedUp:=0;
                SpeedDown:=0;
                SetWindowText(hWnd,pchar('My Windows 3D Engine' + ' [paused]'));
                Refresh:=false;
               end else begin
                SetWindowText(hWnd,pchar('My Windows 3D Engine'));
                Refresh:=true;
               end;
  WM_COMMAND : begin
                case wParam of
                // Game/Exit
                 101 : PostQuitMessage(0);
                // Size :
                 201 : SetWindowPos(hWnd,HWnd_Top,0,0,320,200,swp_nomove);
                 202 : SetWindowPos(hWnd,HWnd_Top,0,0,480,360,swp_nomove);
                 203 : SetWindowPos(hWnd,HWnd_Top,0,0,640,480,swp_nomove);
                // About
                 300 : MessageBox(hWnd,
                       'MyWin3D (C) 1998, Paul TOTH (tothpaul@mygale.org)'+#13#10+
                       'http://www.mygale.org/~tothpaul'+#13#10+
''+#13#10+
'This program is free software; you can redistribute it and/or'+#13#10+
'modify it under the terms of the GNU General Public License'+#13#10+
'as published by the Free Software Foundation; either version 2'+#13#10+
'of the License, or (at your option) any later version.'+#13#10+
''+#13#10+
'This program is distributed in the hope that it will be useful,'+#13#10+
'but WITHOUT ANY WARRANTY; without even the implied warranty of'+#13#10+
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the'+#13#10+
'GNU General Public License for more details.'+#13#10+
''+#13#10+
'You should have received a copy of the GNU General Public License'+#13#10+
'along with this program; if not, write to the Free Software'+#13#10+
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.',
                       'My Windows 3D Engine !',
                       mb_ok or mb_iconinformation
                       );
                // else Messagebox(hWnd,pchar(IntToStr(wparam)),'wm_command',0);
                end;
               end;
  mm_mcinotify : if wParam=MCI_NOTIFY_SUCCESSFUL then Replay; // restart music !
  WM_DESTROY : PostQuitMessage(0);
  else Result:=(DefWindowProc(hWnd, msg, wParam, lParam));
 end;
end;

Function RegisterMe:boolean;
 var
  wc:TWndClass;
 begin
 { Register the window class for my window. }
  wc.style :=  CS_SAVEBITS;            { Class style. }
  wc.lpfnWndProc := @WinProc;          { Window procedure for this class. }
  wc.cbClsExtra := 0;                  { No per-class extra data. }
  wc.cbWndExtra := 0;                  { No per-window extra data. }
  wc.hInstance := hInstance;           { Application that owns the class. }
  wc.hIcon := LoadIcon(hInstance,'MAINICON');  { no icon }
  wc.hCursor := LoadCursor(0, IDC_ARROW); { defaut cursor }
  wc.hbrBackground := 0; // GetStockObject(BLACK_BRUSH); { black screen }
  wc.lpszMenuName := 'MainMenu';       { Name of menu resource in .RC file. }
  wc.lpszClassName := 'TMyWin3D';      { Name used in call to CreateWindow. }
  result:=(RegisterClass(wc)<>0);
 end;

Function StartMe:boolean;
 begin
  { Create a main window for this application instance. }
  hWnd := CreateWindow(
        'TMyWin3D',            { registered class name }
        'My Windows 3D Engine',
        WS_OVERLAPPEDWINDOW or ws_visible,   { Window style. }
        cw_usedefault,         { Default horizontal position. }
        cw_usedefault,         { Default vertical position. }
        320, //cw_usedefault,         { Default width. }
        200, //cw_usedefault,         { Default height. }
        0,                     { Overlapped windows have no parent. }
        0,                     { Use the window class menu. }
        hInstance,             { This instance owns this window. }
        nil                    { Pointer not needed. }
    );
  StartMe:=(HWnd<>0);
 end;

begin
{ read world }
 AssignFile(HWorld,WORLD); Reset(HWorld,1);
 if IoResult<>0 then begin
  MessageBox(0,'World data file '+WORLD+' not found','Damned !',0);
  exit;
 end;
 BlockRead(HWorld,PlayerX,SizeOf(PlayerX));
 BlockRead(HWorld,PlayerY,SizeOf(PlayerY));
 BlockRead(HWorld,PlayerR,SizeOf(PlayerR));
 PlayerA:=PlayerR*128 div 180;
 BlockRead(HWorld,PlayerR,SizeOf(PlayerR));

 BlockRead(HWorld,RoomCount,2);

 GetMem(RoomSize,2*RoomCount);
 BlockRead(HWorld,RoomSize^,2*RoomCount);

{ Reading Rooms DATA }
 GetMem(Rooms,4*RoomCount);
 For Room:=1 to RoomCount do begin
  GetMem(Rooms^[Room],RoomSize^[Room]);
  BlockRead(HWorld,Rooms^[Room]^,RoomSize^[Room]);
 end;

 if IOResult<>0 then begin
  MessageBox(0,'Invalide World data file '+WORLD,'Damned !',0);
  exit;
 end;

 Close(HWorld);

{ Get Wall DATA }
 AssignFile(HPicture,WALLS); Reset(HPicture,1);
 if IoResult<>0 then begin
  MessageBox(0,'Walls data file '+WALLS+' not found','Damned !',0);
  exit;
 end;
 PictureCount:=FileSize(HPicture);
 GetMem(Pictures,PictureCount);
 BlockRead(HPicture,Pictures^,PictureCount);
 PictureCount:=PictureCount div PictureSize;
 Close(HPicture);

{ Get Palette }
 AssignFile(HPalette,GAMEPAL); Reset(HPalette,1);
 if IoResult<>0 then begin
  MessageBox(0,'Palette data file '+GAMEPAL+' not found','Damned !',0);
  exit;
 end;
 GetMem(Palette,PaletteSize);
 BlockRead(HPalette,Palette^,PaletteSize);
 Close(HPalette);

 { windows initialization }
 with bitsinfo do begin
  with bmiheader do begin
   bisize:=40;
//   biwidth:=320;   set with WM_SIZE
//   biheight:=200;
   biplanes:=1;
   bibitcount:=8;
   bicompression:=BI_RGB;
   bisizeimage:=0;
   bixpelspermeter:=0;
   biypelspermeter:=0;
   biclrused:=256;
   biclrimportant:=0;
  end;
  for i:=0 to 255 do bmiColors[i]:=i;
 end;

 StartGame; // create also a Windows HPalette from Palette

 SpeedUp:=0;
 SpeedDown:=0;
 Refresh:=false;

 If RegisterMe and StartMe then begin
  //StartSound(hWnd,'canyon.mid');
    Repeat
     if Refresh then begin
     {$ifdef keystate}
      if GetKeyState(vk_left)<0 then inc(TurnLeft) else TurnLeft:=0;
      if GetKeyState(vk_right)<0 then inc(TurnRight) else TurnRight:=0;
      if GetKeyState(vk_up)<0 then inc(SpeedUp) else SpeedUp:=0;
      if GetKeyState(vk_down)<0 then inc(SpeedDown) else SpeedDown:=0;
     {$endif}
      inc(PlayerA,TurnLeft-TurnRight);
      pSin:=sin(PlayerA*PI/128);
      pCos:=cos(PlayerA*PI/128);
      Speed:=SpeedUp-SpeedDown;
      While Speed<>0 do begin
       MoveX:=PlayerX-round(Speed*pSin);
       MoveY:=PlayerY-round(Speed*pCos);
       if InsideRoom(PlayerR) then begin
        PlayerX:=MoveX;
        PlayerY:=MoveY;
        break;
       end else begin
        if SpeedUp>0 then dec(speedup);
        if SpeedDown>0 then dec(speeddown);
        Speed:=SpeedUp-SpeedDown;
        if speed=0 then PlaySound('bump.wav',0,snd_filename);
       end;
      end;
      ShowView;
      DrawDib;
     end;
     if PeekMessage(Msg,0,0,0,pm_remove) then begin
      TranslateMessage(msg);    { Translates virtual key codes. }
      DispatchMessage(msg);     { Dispatches message to window. }
     end;
    Until Msg.Message=WM_QUIT;
   StopSound;
 end;

 StopGame;

{ Free memory }
 FreeMem(Palette,PaletteSize);
 FreeMem(Pictures,PictureCount*PictureSize);
 For Room:=1 to RoomCount do begin
  FreeMem(Rooms^[Room],RoomSize^[Room]);
 end;
 FreeMem(Rooms,4*RoomCount);
 FreeMem(RoomSize,2*RoomCount);

end.
