Program World;

Uses
 MyDef;

Type
 TRoom1=packed record
  Top   :word;
  Left  :word;
  Right :word;
  Bottom:word;
  Height:integer;
  Count :byte;
  Walls :array[1..6] of TWall;
 end;

 TRoom2=packed record
  Top   :word;
  Left  :word;
  Right :word;
  Bottom:word;
  Height:integer;
  Count :byte;
  Walls :array[1..4] of TWall;
 end;

 TRoom3=packed record
  Top   :word;
  Left  :word;
  Right :word;
  Bottom:word;
  Height:integer;
  Count :byte;
  Walls :array[1..8] of TWall;
 end;

 TRoom4=packed record
  Top   :word;
  Left  :word;
  Right :word;
  Bottom:word;
  Height:integer;
  Count :byte;
  Walls :array[1..4] of TWall;
 end;


 TRoom5=packed record
  Top   :word;
  Left  :word;
  Right :word;
  Bottom:word;
  Height:integer;
  Count :byte;
  Walls :array[1..4] of TWall;
 end;

 THeader=packed record
  PlayerX:Integer;
  PlayerY:Integer;
  PlayerA:Integer;
  PlayerR:Integer;
  RoomCount:word;
  Rooms:array[1..5] of Word;
 end;

Const
 RoomCount:word=4;

 Room1:TRoom1=(
  Top   :0;
  Left  :0;
  Right :5*64;
  Bottom:2*64;
  Height:0;
  Count :6;
  Walls :(                                      {   1   2   3   4   5   6  }
   (Axis:East;  Width:64*5; Door:0; Image:3),   {   +---+---+---+---+---+  }
{  (Axis:East;  Width:64;   Door:0; Image:6),   {   |                   |  }
{  (Axis:East;  Width:64;   Door:0; Image:3),   {   |                   |  }
{  (Axis:East;  Width:64;   Door:0; Image:6),   { 14+                   +7 }
{  (Axis:East;  Width:64;   Door:0; Image:3),   {   |     Room 1        |  }
   (Axis:South; Width:64*2; Door:0; Image:4),   {   |                   |  }
{  (Axis:South; Width:64;   Door:0; Image:4),   { 13+   +   +---+   +   +8 }
   (Axis:West;  Width:64*2; Door:2; Image:0),   {   :  12  11  10   9   :  }
{  (Axis:West;  Width:64;   Door:2; Image:0),   {   :       :   :       :  }
   (Axis:West;  Width:64;   Door:5; Image:0),   {   :       :...:       :  }
   (Axis:West;  Width:64*2; Door:4; Image:0),   {   :                   :  }
{  (Axis:West;  Width:64;   Door:4; Image:0),   {   :                   :  }
   (Axis:North; Width:64*2; Door:0; Image:3)    {   :                   :  }
{  (Axis:North; Width:64;   Door:0; Image:3)    {   :                   :  }
  )                                             {   :...................:  }
 );

 Room2:TRoom2=(
  Top   :2*64;
  Left  :3*64;
  Right :5*64;
  Bottom:3*64;
  Height:+5;
  Count :4;
  Walls :(
   (Axis:East;  Width:64*2; Door:1; Image:0),            {  1   2   3  }
{  (Axis:East;  Width:64;   Door:1; Image:0),            {--+   +   +  }
   (Axis:South; Width:64;   Door:0; Image:4),            {  | Room 2|  }
   (Axis:West;  Width:64*2; Door:3; Image:0),            {  |       |  }
{  (Axis:West;  Width:64;   Door:3; Image:0),            { -+   +   +  }
   (Axis:North; Width:64;   Door:5; Image:0)             {  6   5   4  }
  )
 );

 Room3:TRoom3=(
  Top   :3*64;
  Left  :0;
  Right :5*64;
  Bottom:3*64+32;
  Height:-5;
  Count :8;
  Walls :(                                      {   1   2   3   4   5   6  }
   (Axis:East;  Width:64*2; Door:4; Image:0),   {   +---+---+---+---+---+  }
{  (Axis:East;  Width:64;   Door:4; Image:0),   {   |                   |  }
   (Axis:East;  Width:64;   Door:5; Image:0),   {   |                   |  }
   (Axis:East;  Width:64*2; Door:2; Image:0),   { 14+                   +7 }
{  (Axis:East;  Width:64;   Door:2; Image:0),   {   |     Room 1        |  }
   (Axis:South; Width:32;   Door:0; Image:4),   {   |                   |  }
{  (Axis:South; Width:64;   Door:0; Image:4),   { 13+   +   +---+   +   +8 }
   (Axis:West;  Width:64*2; Door:0; Image:4),   {   :  12  11  10   9   :  }
{  (Axis:West;  Width:64;   Door:0; Image:4),   {   :       :   :       :  }
   (Axis:West;  Width:64;   Door:0; Image:5),   {   :       :...:       :  }
   (Axis:West;  Width:64*2; Door:0; Image:4),   {   :                   :  }
{  (Axis:West;  Width:64;   Door:0; Image:4),   {   :     Room 3        :  }
   (Axis:North; Width:32;   Door:0; Image:3)    {   :                   :  }
{  (Axis:North; Width:64;   Door:0; Image:3)    {   :                   :  }
  )                                             {   :...................:  }
 );

 Room4:TRoom4=(
  Top   :2*64;
  Left  :0;
  Right :2*64;
  Bottom:3*64;
  Height:-10;
  Count :4;
  Walls :(
   (Axis:East;  Width:64*2; Door:1; Image:0),            {  1   2   3  }
{  (Axis:East;  Width:64;   Door:1; Image:0),            {  +   +   +- }
   (Axis:South; Width:64;   Door:5; Image:0),            {  | Room 4|  }
   (Axis:West;  Width:64*2; Door:3; Image:0),            {  |       |  }
{  (Axis:West;  Width:64;   Door:3; Image:0),            {  +   +   +- }
   (Axis:North; Width:64;   Door:0; Image:4)             {  6   5   4  }
  )                                          {             }
 );

 Room5:TRoom5=(
  Top   :2*64;
  Left  :2*64;
  Right :3*64;
  Bottom:3*64;
  Height:+10;
  Count :4;
  Walls :(
   (Axis:East;  Width:64;   Door:1; Image:0),            {  1   2  }
   (Axis:South; Width:64;   Door:2; Image:0),            {  +...+  }
   (Axis:West;  Width:64;   Door:3; Image:0),            {  :   :  }
   (Axis:North; Width:64;   Door:4; Image:0)             {  :   :  }
                                             {  +...+  }
                                             {  4   3  }
  )                                          {         }
 );

 Header:THeader=(
  PlayerX:32;
  PlayerY:32;
  PlayerA:215;
  PlayerR:1;
  RoomCount:5;
  Rooms:(
   SizeOf(Room1),
   SizeOf(Room2),
   SizeOf(Room3),
   SizeOf(Room4),
   SizeOf(Room5)
  )
 );

Var
 f:file;

begin
 assign(f,'world.dat');
 rewrite(f,1);

  { rooms header }
  blockwrite(f,Header,SizeOf(Header));
  { rooms data }
  blockwrite(f,Room1,SizeOf(Room1));
  blockwrite(f,Room2,SizeOf(Room2));
  blockwrite(f,Room3,SizeOf(Room3));
  blockwrite(f,Room4,SizeOf(Room4));
  blockwrite(f,Room5,SizeOf(Room5));

 close(f);

end.